diff a/src/hotspot/cpu/ppc/stackChunkFrameStream_ppc.inline.hpp b/src/hotspot/cpu/ppc/stackChunkFrameStream_ppc.inline.hpp
--- a/src/hotspot/cpu/ppc/stackChunkFrameStream_ppc.inline.hpp
+++ b/src/hotspot/cpu/ppc/stackChunkFrameStream_ppc.inline.hpp
@@ -182,12 +182,13 @@
   InterpreterOopMap mask;
   frame f = to_frame();
   f.interpreted_frame_oop_map(&mask);
   return  mask.num_oops()
           + 1 // for the mirror oop
-          + ((intptr_t*)f.interpreter_frame_monitor_begin()
-             - (intptr_t*)f.interpreter_frame_monitor_end())/BasicObjectLock::size();
+          + (f.interpreter_frame_method()->is_native() ? 1 : 0) // temp oop slot
+          + pointer_delta_as_int((intptr_t*)f.interpreter_frame_monitor_begin(),
+                                 (intptr_t*)f.interpreter_frame_monitor_end())/BasicObjectLock::size();
 }
 
 template<>
 template<>
 inline void StackChunkFrameStream<ChunkFrames::Mixed>::update_reg_map_pd(RegisterMap* map) {
